function ap = apupdate(apo,dms,dml,y,td,tr,c1,c2);
% ap=apupdate(apo,dms,dml,y,td,tr,c1,c2)
%
% function:	update speed control parameter ap(k)
%		implements eq. (7) of recommendation G.726
%
% input:apo	old speed control parameter ap(k-1)
%		dml	long term average of F[I(k)]
%		dms	short term average of F[I(k)]
%		y	quantizer scale factor y(k)
%		td	tone detector
%		tr	transition detector
%		c1	= 2^-3
%		c2	= 1-2^-4
%
% output:	ap	speed control parameter

if tr==1
   ap = 1;
elseif ( abs(dms-dml) >= c1*dml | y < 3 | td==1 )
   ap = c2*apo + c1;
else
   ap = c2*apo;
end;

       
