function bi = biupdate(bio,dq,N,c1,c2,c3);
% BIUPDATE	Update of non-recursive predictor coefficients
% bi=biupdate(bio,dq,N,c1,c2,c3)
%
% function:	update coefficients of sixth-order predictor
%
% input:	bio	old coefficient of sixth-order predictor
%		dq	difference signal vector
%		c1	= 2^-7
%		c2	= 1-2^-8
%		c3	= 1-2^-9
%
% output:	bi	coefficients of sixth-order predictor

% 1995-05-16, Martin Kummernecker
% 1995-08-30, Gernot Kubin (g.kubin@ieee.org)
% Vienna University of Technology, Vienna, Austria

sgndq = sign(dq);
sgndq(2:6) = sign(sgndq(2:6) + 0.5); % modify 0's to 1's
if N == 40
   bi=c3*bio+c1*sgndq(1)*sgndq(2:7);
else
   bi=c2*bio+c1*sgndq(1)*sgndq(2:7);
end;
