function x = speechin(filename);
%
% opens an SPPACK file, reads its contents as short integers,
% and skips over header;
% output is a row vector
%

headerlength = 256;      % SPPACK header length measured by length(short)

[fid, message] = fopen(filename);
if ~isempty(message)
	error(message)
end

x = fread(fid,'short');
x = x(headerlength+1:length(x));
x = x(:)';

status = fclose(fid);
if status ~= 0
	error('SPEECHIN: file was not closed properly')
end

